您的位置:首页 > 其它

hdu 2768(建图,最大点独立集)

2016-07-29 10:32 411 查看

Cat vs. Dog

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2030 Accepted Submission(s): 774


[align=left]Problem Description[/align]
The
latest reality show has hit the TV: ``Cat vs. Dog''. In this show, a
bunch of cats and dogs compete for the very prestigious Best Pet Ever
title. In each episode, the cats and dogs get to show themselves off,
after which the viewers vote on which pets should stay and which should
be forced to leave the show.

Each viewer gets to cast a vote on
two things: one pet which should be kept on the show, and one pet which
should be thrown out. Also, based on the universal fact that everyone is
either a cat lover (i.e. a dog hater) or a dog lover (i.e. a cat
hater), it has been decided that each vote must name exactly one cat and
exactly one dog.

Ingenious as they are, the producers have
decided to use an advancement procedure which guarantees that as many
viewers as possible will continue watching the show: the pets that get
to stay will be chosen so as to maximize the number of viewers who get
both their opinions satisfied. Write a program to calculate this maximum
number of viewers.

[align=left]Input[/align]
On the first line one positive number: the number of testcases, at most 100. After that per testcase:

* One line with three integers c, d, v (1 ≤ c, d ≤ 100 and 0 ≤ v ≤ 500): the number of cats, dogs, and voters.

* v lines with two pet identifiers each. The first is the pet that
this voter wants to keep, the second is the pet that this voter wants to
throw out. A pet identifier starts with one of the characters `C' or
`D', indicating whether the pet is a cat or dog, respectively. The
remaining part of the identifier is an integer giving the number of the
pet (between 1 and c for cats, and between 1 and d for dogs). So for
instance, ``D42'' indicates dog number 42.

[align=left]Output[/align]
Per testcase:

* One line with the maximum possible number of satisfied voters for the show.

[align=left]Sample Input[/align]

2
1 1 2
C1 D1
D1 C1
1 2 4
C1 D1
C1 D1
C1 D2
D2 C1

[align=left]Sample Output[/align]

1
3

题意:有n个人,这些人有人喜欢猫a并且讨厌狗b,有的人喜欢狗c并且讨厌猫d,将这些猫和狗换掉或者留下,问最优情况下满意的人最多有多少?
题解:建图,将人的喜欢与不喜欢建成一个二分图,对于某一只动物,如果甲喜欢乙不喜欢,那么就连一条边,反之也是,由于人是同一个集合,所以连双向边,最终求出最大匹配数,然后求出最大独立集即可。

#include<iostream>
#include<cstdio>
#include<cstring>
#include <algorithm>
#include <math.h>
#include <queue>
using namespace std;
const int N = 505;
int c,d,v;
char a
[10],b
[10];
int graph

;
int linker
;
bool vis
;
bool dfs(int u){
for(int i=1;i<=v;i++){
if(graph[u][i]&&!vis[i]){
vis[i] = true;
if(linker[i]==-1||dfs(linker[i])){
linker[i] = u;
return true;
}
}
}
return false;
}
int main()
{
int tcase;
scanf("%d",&tcase);
while(tcase--){
scanf("%d%d%d",&c,&d,&v);
for(int i=1;i<=v;i++){
scanf("%s%s",a[i],b[i]);
}
memset(graph,0,sizeof(graph));
for(int i=1;i<=v;i++){
for(int j=1;j<=v;j++){
if(strcmp(a[i],b[j])==0||strcmp(a[j],b[i])==0){
graph[i][j] = graph[j][i] = 1;
}
}
}
int res = 0;
memset(linker,-1,sizeof(linker));
for(int i=1;i<=v;i++){
memset(vis,false,sizeof(vis));
if(dfs(i)) res++;
}
printf("%d\n",v-res/2);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: